Index: src/drivers/Xlib/Fl_Xlib_Graphics_Driver_image.cxx
===================================================================
--- src/drivers/Xlib/Fl_Xlib_Graphics_Driver_image.cxx	(revision 12170)
+++ src/drivers/Xlib/Fl_Xlib_Graphics_Driver_image.cxx	(working copy)
@@ -3,7 +3,7 @@
 //
 // Image drawing routines for the Fast Light Tool Kit (FLTK).
 //
-// Copyright 1998-2016 by Bill Spitzak and others.
+// Copyright 1998-2017 by Bill Spitzak and others.
 //
 // This library is free software. Distribution and use rights are outlined in
 // the file "COPYING" which should have been included with this file.  If this
@@ -51,6 +51,7 @@
 #  include <FL/fl_draw.H>
 #  include <FL/x.H>
 #  include <FL/Fl_Image_Surface.H>
+#include <FL/Fl_Screen_Driver.H>
 #  include "../../Fl_XColor.H"
 #  include "../../flstring.h"
 
@@ -571,7 +572,7 @@
   }
 }
 
-void Fl_Xlib_Graphics_Driver::draw_image(const uchar* buf, int x, int y, int w, int h, int d, int l){
+void Fl_Xlib_Graphics_Driver::draw_image_unscaled(const uchar* buf, int x, int y, int w, int h, int d, int l){
 
   const bool alpha = !!(abs(d) & FL_IMAGE_WITH_ALPHA);
   if (alpha) d ^= FL_IMAGE_WITH_ALPHA;
@@ -580,7 +581,7 @@
   innards(buf,x,y,w,h,d,l,mono,0,0,alpha,gc_);
 }
 
-void Fl_Xlib_Graphics_Driver::draw_image(Fl_Draw_Image_Cb cb, void* data,
+void Fl_Xlib_Graphics_Driver::draw_image_unscaled(Fl_Draw_Image_Cb cb, void* data,
 		   int x, int y, int w, int h,int d) {
 
   const bool alpha = !!(abs(d) & FL_IMAGE_WITH_ALPHA);
@@ -590,11 +591,11 @@
   innards(0,x,y,w,h,d,0,mono,cb,data,alpha,gc_);
 }
 
-void Fl_Xlib_Graphics_Driver::draw_image_mono(const uchar* buf, int x, int y, int w, int h, int d, int l){
+void Fl_Xlib_Graphics_Driver::draw_image_mono_unscaled(const uchar* buf, int x, int y, int w, int h, int d, int l){
   innards(buf,x,y,w,h,d,l,1,0,0,0,gc_);
 }
 
-void Fl_Xlib_Graphics_Driver::draw_image_mono(Fl_Draw_Image_Cb cb, void* data,
+void Fl_Xlib_Graphics_Driver::draw_image_mono_unscaled(Fl_Draw_Image_Cb cb, void* data,
 		   int x, int y, int w, int h,int d) {
   innards(0,x,y,w,h,d,0,1,cb,data,0,gc_);
 }
@@ -619,7 +620,7 @@
   XFreePixmap(fl_display, bm);
 }
 
-void Fl_Xlib_Graphics_Driver::draw(Fl_Bitmap *bm, int XP, int YP, int WP, int HP, int cx, int cy) {
+void Fl_Xlib_Graphics_Driver::draw_unscaled(Fl_Bitmap *bm, int XP, int YP, int WP, int HP, int cx, int cy) {
   int X, Y, W, H;
   if (Fl_Graphics_Driver::prepare(bm, XP, YP, WP, HP, cx, cy, X, Y, W, H)) {
     return;
@@ -693,7 +694,7 @@
 }
 
 
-void Fl_Xlib_Graphics_Driver::draw(Fl_RGB_Image *img, int XP, int YP, int WP, int HP, int cx, int cy) {
+void Fl_Xlib_Graphics_Driver::draw_unscaled(Fl_RGB_Image *img, int XP, int YP, int WP, int HP, int cx, int cy) {
   int X, Y, W, H;
   // Don't draw an empty image...
   if (!img->d() || !img->array) {
@@ -718,6 +719,7 @@
       fl_draw_image(img->array, 0, 0, img->w(), img->h(), depth, img->ld());
       Fl_Surface_Device::pop_current();
       *Fl_Graphics_Driver::id(img) = surface->get_offscreen_before_delete();
+      *cache_scale(img) =  Fl_Scalable_Graphics_Driver::scale();
       delete surface;
     }
   }
@@ -740,11 +742,12 @@
   }
 }
 
-fl_uintptr_t Fl_Xlib_Graphics_Driver::cache(Fl_Bitmap*, int w, int h, const uchar *array) {
+fl_uintptr_t Fl_Xlib_Graphics_Driver::cache(Fl_Bitmap *bm, int w, int h, const uchar *array) {
+  *cache_scale(bm) =  Fl_Scalable_Graphics_Driver::scale();
   return (fl_uintptr_t)create_bitmask(w, h, array);
 }
 
-void Fl_Xlib_Graphics_Driver::draw(Fl_Pixmap *pxm, int XP, int YP, int WP, int HP, int cx, int cy) {
+void Fl_Xlib_Graphics_Driver::draw_unscaled(Fl_Pixmap *pxm, int XP, int YP, int WP, int HP, int cx, int cy) {
   int X, Y, W, H;
   if (Fl_Graphics_Driver::prepare(pxm, XP, YP, WP, HP, cx, cy, X, Y, W, H)) return;
   if (*Fl_Graphics_Driver::mask(pxm)) {
@@ -796,6 +799,7 @@
     delete[] bitmap;
   }
   fl_end_offscreen();
+  *cache_scale(img) =  Fl_Scalable_Graphics_Driver::scale();
   return (fl_uintptr_t)id;
 }
 
Index: src/drivers/Xlib/Fl_Xlib_Graphics_Driver_line_style.cxx
===================================================================
--- src/drivers/Xlib/Fl_Xlib_Graphics_Driver_line_style.cxx	(revision 12170)
+++ src/drivers/Xlib/Fl_Xlib_Graphics_Driver_line_style.cxx	(working copy)
@@ -34,10 +34,9 @@
 
 #include "Fl_Xlib_Graphics_Driver.H"
 
-void Fl_Xlib_Graphics_Driver::line_style(int style, int width, char* dashes) {
-
+void Fl_Xlib_Graphics_Driver::line_style_unscaled(int style, float width, char* dashes) {
   // save line width for X11 clipping
-  if (width == 0) line_width_ = 1;
+  if (width == 0) line_width_ = scale_ < 2 ? 0 : scale_;
   else line_width_ = width>0 ? width : -width;
 
   int ndashes = dashes ? strlen(dashes) : 0;
@@ -63,10 +62,12 @@
     case FL_DASHDOTDOT: *p++ = dash; *p++ = gap; *p++ = dot; *p++ = gap; *p++ = dot; *p++ = gap; break;
     }
     ndashes = p-buf;
+if (*dashes == 0) ndashes = 0;//against error with very small scaling
   }
   static int Cap[4] = {CapButt, CapButt, CapRound, CapProjecting};
   static int Join[4] = {JoinMiter, JoinMiter, JoinRound, JoinBevel};
-  XSetLineAttributes(fl_display, gc_, width,
+  XSetLineAttributes(fl_display, gc_,
+                     line_width_,
 		     ndashes ? LineOnOffDash : LineSolid,
 		     Cap[(style>>8)&3], Join[(style>>12)&3]);
   if (ndashes) XSetDashes(fl_display, gc_, 0, dashes, ndashes);
Index: src/drivers/Xlib/Fl_Xlib_Graphics_Driver_rect.cxx
===================================================================
--- src/drivers/Xlib/Fl_Xlib_Graphics_Driver_rect.cxx	(revision 12170)
+++ src/drivers/Xlib/Fl_Xlib_Graphics_Driver_rect.cxx	(working copy)
@@ -163,108 +163,149 @@
 
 // --- line and polygon drawing with integer coordinates
 
-void Fl_Xlib_Graphics_Driver::point(int x, int y) {
-  XDrawPoint(fl_display, fl_window, gc_, clip_x(x), clip_x(y));
-}
 
-void Fl_Xlib_Graphics_Driver::rect(int x, int y, int w, int h) {
-  if (w<=0 || h<=0) return;
+void Fl_Xlib_Graphics_Driver::rect_unscaled(float fx, float fy, float fw, float fh) {
+  if (fw<=0 || fh<=0) return;
+  int x = fx; int y = fy;
+  int w = int(fw+0.5 - scale_); int h = int(fh+0.5 - scale_);
   if (!clip_to_short(x, y, w, h, line_width_))
-    XDrawRectangle(fl_display, fl_window, gc_, x, y, w-1, h-1);
+    XDrawRectangle(fl_display, fl_window, gc_, x+line_delta_, y+line_delta_, w, h);
 }
 
-void Fl_Xlib_Graphics_Driver::rectf(int x, int y, int w, int h) {
-  if (w<=0 || h<=0) return;
+void Fl_Xlib_Graphics_Driver::rectf_unscaled(float fx, float fy, float fw, float fh) {
+  if (fw<=0 || fh<=0) return;
+  int deltaf = scale_ >= 2 ? scale_/2 : 0;
+  int x = fx-deltaf; int y = fy-deltaf;
+  int w = fw; int h = fh;
   if (!clip_to_short(x, y, w, h, line_width_))
-    XFillRectangle(fl_display, fl_window, gc_, x, y, w, h);
+    XFillRectangle(fl_display, fl_window, gc_, x+line_delta_, y+line_delta_, w, h);
 }
 
-void Fl_Xlib_Graphics_Driver::line(int x, int y, int x1, int y1) {
-  XDrawLine(fl_display, fl_window, gc_, x, y, x1, y1);
+void Fl_Xlib_Graphics_Driver::line_unscaled(float x, float y, float x1, float y1) {
+  if (x == x1) yxline_unscaled(x, y, y1);
+  else if (y == y1) xyline_unscaled(x, y, x1);
+  else XDrawLine(fl_display, fl_window, gc_, x+line_delta_, y+line_delta_, x1+line_delta_, y1+line_delta_);
 }
 
-void Fl_Xlib_Graphics_Driver::line(int x, int y, int x1, int y1, int x2, int y2) {
+void Fl_Xlib_Graphics_Driver::line_unscaled(float x, float y, float x1, float y1, float x2, float y2) {
   XPoint p[3];
-  p[0].x = x;  p[0].y = y;
-  p[1].x = x1; p[1].y = y1;
-  p[2].x = x2; p[2].y = y2;
+  p[0].x = x+line_delta_;  p[0].y = y+line_delta_;
+  p[1].x = x1+line_delta_; p[1].y = y1+line_delta_;
+  p[2].x = x2+line_delta_; p[2].y = y2+line_delta_;
   XDrawLines(fl_display, fl_window, gc_, p, 3, 0);
 }
 
-void Fl_Xlib_Graphics_Driver::xyline(int x, int y, int x1) {
-  XDrawLine(fl_display, fl_window, gc_, clip_x(x), clip_x(y), clip_x(x1), clip_x(y));
+
+void Fl_Xlib_Graphics_Driver::xyline_unscaled(float x, float y, float x1) {
+  if (scale_ >= 2) {
+    rectf_unscaled(x,y+line_delta_-line_width_/2, line_width_, line_width_);
+    rectf_unscaled(x1,y+line_delta_-line_width_/2, line_width_, line_width_);
+  }
+  int ix = clip_x(x+line_delta_);
+  int iy = clip_x(y+line_delta_);
+  int ix1 = clip_x(x1+line_delta_);
+  XDrawLine(fl_display, fl_window, gc_, ix, iy, ix1, iy);
+  // TO TEST: attempt to improve box drawing with fractional scaling factor
+  int tw = line_width_ ? line_width_ : 1; // true line width
+  if (y+line_delta_ + scale_ >= iy + tw+1 -0.001) XDrawLine(fl_display, fl_window, gc_, ix, iy+1, ix1, iy+1);
 }
 
-void Fl_Xlib_Graphics_Driver::xyline(int x, int y, int x1, int y2) {
+void Fl_Xlib_Graphics_Driver::xyline_unscaled(float x, float y, float x1, float y2) {
+  if (scale_ >= 2) {
+    rectf_unscaled(x,y+line_delta_-line_width_/2, line_width_, line_width_);
+    rectf_unscaled(x1+line_delta_-line_width_/2,y2, line_width_, line_width_);
+  }
   XPoint p[3];
-  p[0].x = clip_x(x);  p[0].y = p[1].y = clip_x(y);
-  p[1].x = p[2].x = clip_x(x1); p[2].y = clip_x(y2);
+  p[0].x = clip_x(x+line_delta_);  p[0].y = p[1].y = clip_x(y+line_delta_);
+  p[1].x = p[2].x = clip_x(x1+line_delta_); p[2].y = clip_x(y2+line_delta_);
   XDrawLines(fl_display, fl_window, gc_, p, 3, 0);
 }
 
-void Fl_Xlib_Graphics_Driver::xyline(int x, int y, int x1, int y2, int x3) {
+void Fl_Xlib_Graphics_Driver::xyline_unscaled(float x, float y, float x1, float y2, float x3) {
+  if (scale_ >= 2) {
+    rectf_unscaled(x,y+line_delta_-line_width_/2, line_width_, line_width_);
+    rectf_unscaled(x3,y2+line_delta_-line_width_/2, line_width_, line_width_);
+  }
   XPoint p[4];
-  p[0].x = clip_x(x);  p[0].y = p[1].y = clip_x(y);
-  p[1].x = p[2].x = clip_x(x1); p[2].y = p[3].y = clip_x(y2);
-  p[3].x = clip_x(x3);
+  p[0].x = clip_x(x+line_delta_);  p[0].y = p[1].y = clip_x(y+line_delta_);
+  p[1].x = p[2].x = clip_x(x1+line_delta_); p[2].y = p[3].y = clip_x(y2+line_delta_);
+  p[3].x = clip_x(x3+line_delta_);
   XDrawLines(fl_display, fl_window, gc_, p, 4, 0);
 }
 
-void Fl_Xlib_Graphics_Driver::yxline(int x, int y, int y1) {
-  XDrawLine(fl_display, fl_window, gc_, clip_x(x), clip_x(y), clip_x(x), clip_x(y1));
+void Fl_Xlib_Graphics_Driver::yxline_unscaled(float x, float y, float y1) {
+  if (scale_ >= 2) {
+    rectf_unscaled(x+line_delta_-line_width_/2,y, line_width_, line_width_);
+    rectf_unscaled(x+line_delta_-line_width_/2,y1, line_width_, line_width_);
+  }
+  int ix = clip_x(x+line_delta_);
+  int iy = clip_x(y+line_delta_);
+  int iy1 = clip_x(y1+line_delta_);
+  XDrawLine(fl_display, fl_window, gc_, ix, iy, ix, iy1);
+  // TO TEST: attempt to improve box drawing with fractional scaling factor
+  int tw = line_width_ ? line_width_ : 1; // true line width
+  if (x+line_delta_+scale_ >= ix + tw+1 -0.001) XDrawLine(fl_display, fl_window, gc_, ix+1, iy, ix+1, iy1);
 }
 
-void Fl_Xlib_Graphics_Driver::yxline(int x, int y, int y1, int x2) {
+void Fl_Xlib_Graphics_Driver::yxline_unscaled(float x, float y, float y1, float x2) {
+  if (scale_ >= 2) {
+    rectf_unscaled(x+line_delta_-line_width_/2,y, line_width_, line_width_);
+    rectf_unscaled(x2,y1+line_delta_-line_width_/2, line_width_, line_width_);
+  }
   XPoint p[3];
-  p[0].x = p[1].x = clip_x(x);  p[0].y = clip_x(y);
-  p[1].y = p[2].y = clip_x(y1); p[2].x = clip_x(x2);
+  p[0].x = p[1].x = clip_x(x+line_delta_);  p[0].y = clip_x(y+line_delta_);
+  p[1].y = p[2].y = clip_x(y1+line_delta_); p[2].x = clip_x(x2+line_delta_);
   XDrawLines(fl_display, fl_window, gc_, p, 3, 0);
 }
 
-void Fl_Xlib_Graphics_Driver::yxline(int x, int y, int y1, int x2, int y3) {
+void Fl_Xlib_Graphics_Driver::yxline_unscaled(float x, float y, float y1, float x2, float y3) {
+  if (scale_ >= 2) {
+    rectf_unscaled(x+line_delta_-line_width_/2,y, line_width_, line_width_);
+    rectf_unscaled(x2+line_delta_-line_width_/2,y3, line_width_, line_width_);
+  }
   XPoint p[4];
-  p[0].x = p[1].x = clip_x(x);  p[0].y = clip_x(y);
-  p[1].y = p[2].y = clip_x(y1); p[2].x = p[3].x = clip_x(x2);
-  p[3].y = clip_x(y3);
+  p[0].x = p[1].x = clip_x(x+line_delta_);  p[0].y = clip_x(y+line_delta_);
+  p[1].y = p[2].y = clip_x(y1+line_delta_); p[2].x = p[3].x = clip_x(x2+line_delta_);
+  p[3].y = clip_x(y3+line_delta_);
   XDrawLines(fl_display, fl_window, gc_, p, 4, 0);
 }
 
-void Fl_Xlib_Graphics_Driver::loop(int x, int y, int x1, int y1, int x2, int y2) {
+void Fl_Xlib_Graphics_Driver::loop_unscaled(float x, float y, float x1, float y1, float x2, float y2) {
   XPoint p[4];
-  p[0].x = x;  p[0].y = y;
-  p[1].x = x1; p[1].y = y1;
-  p[2].x = x2; p[2].y = y2;
-  p[3].x = x;  p[3].y = y;
+  p[0].x = x +line_delta_;  p[0].y = y +line_delta_;
+  p[1].x = x1 +line_delta_; p[1].y = y1 +line_delta_;
+  p[2].x = x2 +line_delta_; p[2].y = y2 +line_delta_;
+  p[3].x = x +line_delta_;  p[3].y = y +line_delta_;
   XDrawLines(fl_display, fl_window, gc_, p, 4, 0);
 }
 
-void Fl_Xlib_Graphics_Driver::loop(int x, int y, int x1, int y1, int x2, int y2, int x3, int y3) {
+void Fl_Xlib_Graphics_Driver::loop_unscaled(float x, float y, float x1, float y1, float x2, float y2, float x3, float y3) {
   XPoint p[5];
-  p[0].x = x;  p[0].y = y;
-  p[1].x = x1; p[1].y = y1;
-  p[2].x = x2; p[2].y = y2;
-  p[3].x = x3; p[3].y = y3;
-  p[4].x = x;  p[4].y = y;
+  p[0].x = x+line_delta_;  p[0].y = y+line_delta_;
+  p[1].x = x1 +line_delta_; p[1].y = y1+line_delta_;
+  p[2].x = x2+line_delta_; p[2].y = y2+line_delta_;
+  p[3].x = x3+line_delta_; p[3].y = y3+line_delta_;
+  p[4].x = x+line_delta_;  p[4].y = y+line_delta_;
   XDrawLines(fl_display, fl_window, gc_, p, 5, 0);
 }
 
-void Fl_Xlib_Graphics_Driver::polygon(int x, int y, int x1, int y1, int x2, int y2) {
+void Fl_Xlib_Graphics_Driver::polygon_unscaled(float x, float y, float x1, float y1, float x2, float y2) {
   XPoint p[4];
-  p[0].x = x;  p[0].y = y;
-  p[1].x = x1; p[1].y = y1;
-  p[2].x = x2; p[2].y = y2;
-  p[3].x = x;  p[3].y = y;
+  p[0].x = x+line_delta_;  p[0].y = y+line_delta_;
+  p[1].x = x1+line_delta_; p[1].y = y1+line_delta_;
+  p[2].x = x2+line_delta_; p[2].y = y2+line_delta_;
+  p[3].x = x+line_delta_;  p[3].y = y+line_delta_;
   XFillPolygon(fl_display, fl_window, gc_, p, 3, Convex, 0);
   XDrawLines(fl_display, fl_window, gc_, p, 4, 0);
 }
 
-void Fl_Xlib_Graphics_Driver::polygon(int x, int y, int x1, int y1, int x2, int y2, int x3, int y3) {
+void Fl_Xlib_Graphics_Driver::polygon_unscaled(float x, float y, float x1, float y1, float x2, float y2, float x3, float y3) {
   XPoint p[5];
-  p[0].x = x;  p[0].y = y;
-  p[1].x = x1; p[1].y = y1;
-  p[2].x = x2; p[2].y = y2;
-  p[3].x = x3; p[3].y = y3;
-  p[4].x = x;  p[4].y = y;
+  p[0].x = x+line_delta_;  p[0].y = y+line_delta_;
+  p[1].x = x1+line_delta_; p[1].y = y1+line_delta_;
+  p[2].x = x2+line_delta_; p[2].y = y2+line_delta_;
+  p[3].x = x3+line_delta_; p[3].y = y3+line_delta_;
+  p[4].x = x+line_delta_;  p[4].y = y+line_delta_;
   XFillPolygon(fl_display, fl_window, gc_, p, 4, Convex, 0);
   XDrawLines(fl_display, fl_window, gc_, p, 5, 0);
 }
@@ -342,8 +383,12 @@
 void Fl_Xlib_Graphics_Driver::restore_clip() {
   fl_clip_state_number++;
   if (gc_) {
-    Fl_Region r = rstack[rstackptr];
-    if (r) XSetRegion(fl_display, gc_, r);
+    Region r = rstack[rstackptr];
+    if (r) {
+      Region r2 = scale_clip(scale_);
+      XSetRegion(fl_display, gc_, r);
+      unscale_clip(r2);
+    }
     else XSetClipMask(fl_display, gc_, 0);
   }
 }
Index: src/drivers/Xlib/Fl_Xlib_Graphics_Driver_vertex.cxx
===================================================================
--- src/drivers/Xlib/Fl_Xlib_Graphics_Driver_vertex.cxx	(revision 12170)
+++ src/drivers/Xlib/Fl_Xlib_Graphics_Driver_vertex.cxx	(working copy)
@@ -30,14 +30,6 @@
 #include <FL/math.h>
 
 
-void Fl_Xlib_Graphics_Driver::transformed_vertex(double xf, double yf) {
-  transformed_vertex0(short(rint(xf)), short(rint(yf)));
-}
-
-void Fl_Xlib_Graphics_Driver::vertex(double x,double y) {
-  transformed_vertex0(short(x*m.a + y*m.c + m.x), short(x*m.b + y*m.d + m.y));
-}
-
 void Fl_Xlib_Graphics_Driver::end_points() {
   if (n>1) XDrawPoints(fl_display, fl_window, gc_, (XPoint*)p, n, 0);
 }
@@ -52,7 +44,9 @@
 
 void Fl_Xlib_Graphics_Driver::end_loop() {
   fixloop();
-  if (n>2) transformed_vertex((short)p[0].x, (short)p[0].y);
+  if (n>2) {
+    transformed_vertex0(p[0].x, p[0].y);
+  }
   end_line();
 }
 
@@ -73,7 +67,7 @@
 void Fl_Xlib_Graphics_Driver::gap() {
   while (n>gap_+2 && p[n-1].x == p[gap_].x && p[n-1].y == p[gap_].y) n--;
   if (n > gap_+2) {
-    transformed_vertex((short)p[gap_].x, (short)p[gap_].y);
+    transformed_vertex0(p[gap_].x, p[gap_].y);
     gap_ = n;
   } else {
     n = gap_;
@@ -92,19 +86,14 @@
 // shortcut the closed circles so they use XDrawArc:
 // warning: these do not draw rotated ellipses correctly!
 // See fl_arc.c for portable version.
-
-void Fl_Xlib_Graphics_Driver::circle(double x, double y,double r) {
-  double xt = transform_x(x,y);
-  double yt = transform_y(x,y);
-  double rx = r * (m.c ? sqrt(m.a*m.a+m.c*m.c) : fabs(m.a));
-  double ry = r * (m.b ? sqrt(m.b*m.b+m.d*m.d) : fabs(m.d));
+void Fl_Xlib_Graphics_Driver::ellipse_unscaled(double xt, double yt, double rx, double ry) {
   int llx = (int)rint(xt-rx);
   int w = (int)rint(xt+rx)-llx;
   int lly = (int)rint(yt-ry);
   int h = (int)rint(yt+ry)-lly;
-
+  
   (what == POLYGON ? XFillArc : XDrawArc)
-    (fl_display, fl_window, gc_, llx, lly, w, h, 0, 360*64);
+  (fl_display, fl_window, gc_, llx, lly, w, h, 0, 360*64);
 }
 
 //
Index: src/drivers/Xlib/Fl_Xlib_Image_Surface_Driver.cxx
===================================================================
--- src/drivers/Xlib/Fl_Xlib_Image_Surface_Driver.cxx	(revision 12170)
+++ src/drivers/Xlib/Fl_Xlib_Image_Surface_Driver.cxx	(working copy)
@@ -24,10 +24,13 @@
 #include "Fl_Xlib_Graphics_Driver.H"
 #include <FL/Fl_Image_Surface.H>
 #include "Fl_Translated_Xlib_Graphics_Driver.H"
+#include <FL/Fl_Screen_Driver.H>
 
 class Fl_Xlib_Image_Surface_Driver : public Fl_Image_Surface_Driver {
   friend class Fl_Image_Surface;
   virtual void end_current_();
+protected:
+  int pixmap_w, pixmap_h;
 public:
   Window pre_window;
   int was_high;
@@ -45,11 +48,20 @@
 }
 
 Fl_Xlib_Image_Surface_Driver::Fl_Xlib_Image_Surface_Driver(int w, int h, int high_res, Fl_Offscreen off) : Fl_Image_Surface_Driver(w, h, high_res, off) {
+  float d = 1;
   if (!off) {
     fl_open_display();
+    d =  fl_graphics_driver->scale();
+    if (d != 1 && high_res) {
+      w = int(w*d);
+      h = int(h*d);
+    }
+    pixmap_w = w;
+    pixmap_h = h;
     offscreen = XCreatePixmap(fl_display, RootWindow(fl_display, fl_screen), w, h, fl_visual->depth);
   }
   driver(new Fl_Translated_Xlib_Graphics_Driver());
+  if (d != 1 && high_res) ((Fl_Translated_Xlib_Graphics_Driver*)driver())->scale(d);
 }
 
 Fl_Xlib_Image_Surface_Driver::~Fl_Xlib_Image_Surface_Driver() {
@@ -74,9 +86,7 @@
 
 Fl_RGB_Image* Fl_Xlib_Image_Surface_Driver::image()
 {
-  unsigned char *data = fl_read_image(NULL, 0, 0, width, height, 0);
-  Fl_RGB_Image *image = new Fl_RGB_Image(data, width, height);
-  image->alloc_array = 1;
+  Fl_RGB_Image *image = Fl::screen_driver()->read_win_rectangle(NULL, 0, 0, width, height, 0);
   return image;
 }
 
Index: src/fl_boxtype.cxx
===================================================================
--- src/fl_boxtype.cxx	(revision 12170)
+++ src/fl_boxtype.cxx	(working copy)
@@ -3,7 +3,7 @@
 //
 // Box drawing code for the Fast Light Tool Kit (FLTK).
 //
-// Copyright 1998-2015 by Bill Spitzak and others.
+// Copyright 1998-2017 by Bill Spitzak and others.
 //
 // This library is free software. Distribution and use rights are outlined in
 // the file "COPYING" which should have been included with this file.  If this
@@ -210,9 +210,14 @@
 
 /** Draws a box of type FL_UP_BOX */
 void fl_up_box(int x, int y, int w, int h, Fl_Color c) {
+  /*fl_up_frame(x,y,w,h,c);
+  Fl::set_box_color(c);
+  fl_rectf(x+D1, y+D1, w-D2, h-D2);*/
+  Fl::set_box_color(c);
+  Fl_Color b = fl_color();
+  fl_rectf(x, y, w, h);
   fl_up_frame(x,y,w,h,c);
-  Fl::set_box_color(c);
-  fl_rectf(x+D1, y+D1, w-D2, h-D2);
+  fl_color(b);
 }
 
 /** Draws a frame of type FL_DOWN_FRAME */
@@ -230,9 +235,11 @@
 
 /** Draws a box of type FL_DOWN_BOX */
 void fl_down_box(int x, int y, int w, int h, Fl_Color c) {
+  Fl::set_box_color(c);
+  Fl_Color b = fl_color();
+  fl_rectf(x, y, w, h);
   fl_down_frame(x,y,w,h,c);
-  Fl::set_box_color(c);
-  fl_rectf(x+D1, y+D1, w-D2, h-D2);
+  fl_color(b);
 }
 
 /** Draws a frame of type FL_ENGRAVED_FRAME */
@@ -242,9 +249,14 @@
 
 /** Draws a box of type FL_ENGRAVED_BOX */
 void fl_engraved_box(int x, int y, int w, int h, Fl_Color c) {
+  /*fl_engraved_frame(x,y,w,h,c);
+  Fl::set_box_color(c);
+  fl_rectf(x+2, y+2, w-4, h-4);*/
+  Fl::set_box_color(c);
+  Fl_Color b = fl_color();
+  fl_rectf(x, y, w, h);
   fl_engraved_frame(x,y,w,h,c);
-  Fl::set_box_color(c);
-  fl_rectf(x+2, y+2, w-4, h-4);
+  fl_color(b);
 }
 
 /** Draws a frame of type FL_EMBOSSED_FRAME */
@@ -254,9 +266,14 @@
 
 /** Draws a box of type FL_EMBOSSED_BOX */
 void fl_embossed_box(int x, int y, int w, int h, Fl_Color c) {
+  /*fl_embossed_frame(x,y,w,h,c);
+  Fl::set_box_color(c);
+  fl_rectf(x+2, y+2, w-4, h-4);*/
+  Fl::set_box_color(c);
+  Fl_Color b = fl_color();
+  fl_rectf(x, y, w, h);
   fl_embossed_frame(x,y,w,h,c);
-  Fl::set_box_color(c);
-  fl_rectf(x+2, y+2, w-4, h-4);
+  fl_color(b);
 }
 
 /**
Index: src/fl_draw.cxx
===================================================================
--- src/fl_draw.cxx	(revision 12170)
+++ src/fl_draw.cxx	(working copy)
@@ -64,7 +64,7 @@
       // test for word-wrap:
       if (word_start < p && wrap) {
 	double newwidth = w + fl_width(word_end, (int) (o-word_end) );
-	if (word_end > buf && newwidth > maxw) { // break before this word
+	if (word_end > buf && int(newwidth) > maxw) { // break before this word
 	  o = word_end;
 	  p = word_start;
 	  break;
Index: src/fl_vertex.cxx
===================================================================
--- src/fl_vertex.cxx	(revision 12170)
+++ src/fl_vertex.cxx	(working copy)
@@ -78,16 +78,6 @@
   }
 }
 
-/** see fl_scale(double, double) */
-void Fl_Graphics_Driver::scale(double x, double y) {
-  mult_matrix(x,0,0,y,0,0);
-}
-
-/** see fl_scale(double) */
-void Fl_Graphics_Driver::scale(double x) {
-  mult_matrix(x,0,0,x,0,0);
-}
-
 /** see fl_translate() */
 void Fl_Graphics_Driver::translate(double x,double y) {
   mult_matrix(1,0,0,1,x,y);
Index: test/offscreen.cxx
===================================================================
--- test/offscreen.cxx	(revision 12170)
+++ test/offscreen.cxx	(working copy)
@@ -68,6 +68,7 @@
   int page_x, page_y; // top left of view area
   // Width and height of the offscreen surface
   int offsc_w, offsc_h;
+  int iters; // Must be set on first pass!
 };
 
 /*****************************************************************************/
@@ -77,7 +78,8 @@
   x1(0), y1(0), drag_state(0), // not dragging view
   page_x((offscreen_size - win_size) / 2), // roughly centred in view
   page_y((offscreen_size - win_size) / 2),
-  offsc_w(0), offsc_h(0) // offscreen size - initially none
+  offsc_w(0), offsc_h(0), // offscreen size - initially none
+  iters(num_iterations + 1)
 { } // Constructor
 
 /*****************************************************************************/
@@ -110,6 +112,12 @@
 int oscr_box::handle(int ev)
 {
   int ret = Fl_Box::handle(ev);
+  
+  if (ev == FL_HIDE && oscr) {
+      fl_delete_offscreen(oscr);
+      oscr = 0;
+      iters = num_iterations + 1;
+  }
   // handle dragging of visible page area - if a valid context exists
   if (has_oscr())
   {
@@ -184,7 +192,6 @@
   static int icol = first_useful_color;
   static int ox = (offscreen_size / 2);
   static int oy = (offscreen_size / 2);
-  static int iters = num_iterations + 1; // Must be set on first pass!
 
   if (!has_oscr())
   {
